<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/langref.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'ja',
  ),
  'this' => 
  array (
    0 => 'language.fibers.php',
    1 => 'ファイバー',
  ),
  'up' => 
  array (
    0 => 'langref.php',
    1 => '言語リファレンス',
  ),
  'prev' => 
  array (
    0 => 'language.exceptions.extending.php',
    1 => '例外を拡張する',
  ),
  'next' => 
  array (
    0 => 'language.generators.php',
    1 => 'ジェネレータ',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'ja',
    'path' => 'language/fibers.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="language.fibers" class="chapter">
 <h1 class="title">ファイバー</h1>


 <div class="simplesect" id="language.fibers.overview">
  <h3 class="title">ファイバーの概要</h3>
  <p class="verinfo">(PHP 8 &gt;= 8.1.0)</p>
  <p class="para">
   ファイバー(Fibers) は、完全なスタックを持つ、停止可能な関数です。 
   ファイバー はコールスタック中のどこからでも停止することができますし、
   後に再開されるまで実行を停止したままにできます。 
  </p>
  <p class="para">
   ファイバーは実行スタック全体を停止するので、
   関数を直接呼び出している側は、関数の呼び出し方を変更する必要はありません。
  </p>
  <p class="para">
   実行スタック中のどこからでも、 
   <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>
   を使って実行を停止できます。
   (つまり、<span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>
   の呼び出しは、
   深くネストされた関数のコールスタックの中から行っても構いませんし、
   呼び出しが全く存在しなくても構いません)
  </p>
  <p class="para">
   スタックを持たない <span class="classname"><a href="class.generator.php" class="classname">Generator</a></span> と異なり、
   個々の <span class="classname"><a href="class.fiber.php" class="classname">Fiber</a></span> は自分のコールスタックを持ちます。
   これによって、深くネストされた関数のコールスタックの中からでも
   関数を停止できます。
   停止ポイントを宣言した
   (つまり、<span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> を呼び出した)
   関数は、
   <a href="language.generators.syntax.php#control-structures.yield" class="link">yield</a> を使った、<span class="classname"><a href="class.generator.php" class="classname">Generator</a></span>
   のインスタンスを返さなければならない関数と異なり、
   戻り値の型を宣言する必要はありません。
  </p>
  <p class="para">
   ファイバーは任意の関数をコールしている間に停止できます。
   これには、PHP VM の中からコールされた関数も含みます。
   たとえば、<span class="function"><a href="function.array-map.php" class="function">array_map()</a></span>
   に渡した関数や、
   <a href="control-structures.foreach.php" class="link">foreach</a> によってコールされる、<span class="classname"><a href="class.iterator.php" class="classname">Iterator</a></span>
   オブジェクトのメソッドなどです。
  </p>
  <p class="para">
   いったんファイバーが停止されると、
   ファイバーの実行は <span class="methodname"><a href="fiber.resume.php" class="methodname">Fiber::resume()</a></span>
   に任意の値を渡すか、
   <span class="methodname"><a href="fiber.throw.php" class="methodname">Fiber::throw()</a></span>
   を使ってファイバーに例外をスローさせることで再開できます。
   再開される時は、<span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>
   から値が返されます(または、例外がスローされます)。
  </p>
  <blockquote class="note"><p><strong class="note">注意</strong>: 
   <span class="simpara">
    現状の制限により、
    ファイバーをオブジェクトのデストラクタ中で切り替えることはできません。
   </span>
  </p></blockquote> 

  <div class="example" id="odbc-procedurecolumns.example.basic">
   <p><strong>例1 ファイバーの基本的な使い方</strong></p>
   <div class="example-contents">
    <div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$fiber </span><span style="color: #007700">= new </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">(function (): </span><span style="color: #0000BB">void </span><span style="color: #007700">{<br />   </span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">::</span><span style="color: #0000BB">suspend</span><span style="color: #007700">(</span><span style="color: #DD0000">'fiber'</span><span style="color: #007700">);<br />   echo </span><span style="color: #DD0000">"Value used to resume fiber: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">start</span><span style="color: #007700">();<br /><br />echo </span><span style="color: #DD0000">"Value from fiber suspending: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br /><br /></span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">resume</span><span style="color: #007700">(</span><span style="color: #DD0000">'test'</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   <div class="example-contents"><p>上の例の出力は以下となります。</p></div>
   <div class="example-contents screen">
    <div class="cdata"><pre>
Value from fiber suspending: fiber
Value used to resume fiber: test
</pre></div>
   </div>
  </div>

 </div>

</div>
<?php manual_footer($setup); ?>